{# 
From https://www.codeinwp.com/snippets/accessible-pure-css-tabs/#gref
For usage of peer, see https://tailwindcss.com/docs/hover-focus-and-other-states#differentiating-peers 
#}
{% import 'actions.html' as macros %}

{%- macro input_output(title, artefacts) -%}
    <div class="mt-8 px-4">
        <div class="px-2 text-lg font-semibold">{{ title }}</div>
        <div class="mt-5 h-[36rem] overflow-auto rounded px-2">
            {% for artefact in artefacts %}
                <div class="mb-1 border-b-2 border-b-gray-300 py-2 text-left font-semibold">
                    {{ artefact.properties.type }}
                </div>
                {{ artefact.html | safe }}
            {% else %}
                <div class="inline-flex items-center text-gray-400">
                    <img
                        src="/static/information_sign_gray.svg"
                        alt="Information sign"
                        class="m-3 h-7 w-7"
                    />
                    <div>No artefacts</div>
                </div>
            {% endfor %}
        </div>
    </div>
{%- endmacro -%}

{%- macro stdout_stderr(title, artefact) -%}
    <div class="px-2 text-lg font-semibold">{{ title }}</div>
    <div class="mt-5 h-[36rem] w-full overflow-y-auto overflow-x-hidden px-2 font-mono text-xs">
        {% if artefact and artefact.output %}
            {% set html_output = artefact.output | ansi2html %}
            {% set lines = html_output.rstrip("\n").split('\n') %}
            {%- for line in lines -%}
                <div class="grid grid-cols-[auto,1fr]">
                    <span
                        class="mr-2 w-9 overflow-x-hidden text-right text-gray-400 hover:overflow-x-visible"
                        >{{ loop.index }}</span
                    >
                    <span class="break-all border-l-2 border-gray-200 pl-2">{{ line | safe }}</span>
                </div>
            {%- endfor -%}
        {% else %}
            <div class="inline-flex items-center font-sans text-sm text-gray-400">
                <img
                    src="/static/information_sign_gray.svg"
                    alt="Information sign"
                    class="m-3 h-7 w-7"
                />
                <div>No logs available</div>
            </div>
        {% endif %}
    </div>
{%- endmacro -%}

<div id="modal-contents" class="w-full max-w-screen-lg rounded bg-white bg-opacity-100 p-5 shadow">
    <div class="flex flex-col-reverse">
        <button
            _="on click hide #modal-{{ workflow_step.maestro_id }} with visibility then set innerHTML of #modal-{{ workflow_step.maestro_id }} to ' '"
            type="button"
            class="bg-ellablue-darkest hover:bg-ellablue-darker mb-3 w-24 self-end rounded-md px-2 py-1 text-sm text-white"
            title="Close modal"
        >
            Close
        </button>
    </div>

    <div class="block w-full overflow-hidden text-sm">
        <!-- tab labels -->
        <input
            class="peer/input absolute opacity-0"
            name="tabs-{{ workflow_step.maestro_id }}"
            type="radio"
            id="input-{{ workflow_step.maestro_id }}"
            checked
        />
        <label
            class="peer-checked/input:border-ellablue-darkest peer-checked/input:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="input-{{ workflow_step.maestro_id }}"
            >Input</label
        >
        <input
            class="peer/output absolute opacity-0"
            name="tabs-{{ workflow_step.maestro_id }}"
            type="radio"
            id="output-{{ workflow_step.maestro_id }}"
        />
        <label
            class="peer-checked/output:border-ellablue-darkest peer-checked/output:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="output-{{ workflow_step.maestro_id }}"
            >Output</label
        >
        <input
            class="peer/stdout absolute opacity-0"
            name="tabs-{{ workflow_step.maestro_id }}"
            type="radio"
            id="stdout-{{ workflow_step.maestro_id }}"
        />
        <label
            class="peer-checked/stdout:border-ellablue-darkest peer-checked/stdout:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="stdout-{{ workflow_step.maestro_id }}"
            >Std out</label
        >
        <input
            class="peer/stderr absolute opacity-0"
            name="tabs-{{ workflow_step.maestro_id }}"
            type="radio"
            id="stderr-{{ workflow_step.maestro_id }}"
        />
        <label
            class="peer-checked/stderr:border-ellablue-darkest peer-checked/stderr:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="stderr-{{ workflow_step.maestro_id }}"
            >Std err</label
        >
        <input
            class="peer/action absolute opacity-0"
            name="tabs-{{ workflow_step.maestro_id }}"
            type="radio"
            id="action-{{ workflow_step.maestro_id }}"
        />
        <label
            class="peer-checked/action:border-ellablue-darkest peer-checked/action:text-ellablue-darkest ml-4 cursor-pointer whitespace-nowrap border-b-2 border-transparent px-2 py-4 text-sm font-medium text-gray-500 hover:border-gray-300 hover:text-gray-700"
            for="action-{{ workflow_step.maestro_id }}"
            >Action</label
        >
        <!-- tab content -->
        <div class="hidden peer-checked/input:block">
            {{ input_output("Artefacts: Input", workflow_step_artefacts.INPUT) }}
        </div>
        <div class="hidden peer-checked/output:block">
            {{ input_output("Artefacts: Output", workflow_step_artefacts.OUTPUT) }}
        </div>
        <div class="mt-8 hidden px-4 peer-checked/stdout:block">
            {{ stdout_stderr("Log: Standard out", workflow_step_artefacts.STDOUT) }}
        </div>
        <div class="mt-8 hidden px-4 peer-checked/stderr:block">
            {{ stdout_stderr("Log: Standard error", workflow_step_artefacts.STDERR) }}
        </div>
        <div class="mt-8 hidden px-4 peer-checked/action:block">
            <div class="px-2 text-lg font-semibold">Action: Steps or artefacts</div>
            <div class="mt-5 h-[36rem] overflow-auto rounded px-2">
                <!-- Warning message -->
                <div
                    class="bg-ellared-light border-ellared-darker mb-5 inline-flex w-full items-center justify-center rounded-lg border py-1"
                >
                    <img src="/static/warning_sign.svg" alt="Warning sign" class="m-3 h-6 w-6" />
                    <div class="text-gray-500">
                        Use actions below with caution, as they cannot be undone!
                    </div>
                </div>
                <!-- Pane for invalidation actions -->
                <div class="float-left w-1/2 pr-4">
                    <!-- Invalidate workflow step -->
                    <div class="mb-2 font-medium">Invalidate all output from step</div>
                    <div class="mb-2 text-gray-500">
                        This will invalidate <span class="italic">all</span> output artefacts from
                        this step. Propagation will also affect all downstream steps.
                    </div>
                    <!--  Invalidate button with dialogue  -->
                    <div class="mx-2 my-3">
                        {{ macros.invalidate(workflow_step.invalidated_at, job_status, workflow_step.maestro_id, "workflow_step", "propagate") }}
                    </div>
                    <!-- Invalidated artefacts -->
                    <div class="mb-2 mt-8 font-medium">Invalidate individual artefacts</div>
                    <div class="mb-2 text-gray-500">
                        Invalidate individual output artefacts here. Propagation will also affect
                        all downstream steps using the artefact.
                    </div>
                    <div id="invalidate-artefact-container">
                        {% set artefact_count = workflow_step_artefacts.OUTPUT|length %}
                        {% if artefact_count == 0 %}
                            <div
                                class="ml-2 mt-1 inline-flex items-center font-sans text-sm text-gray-400"
                            >
                                <img
                                    src="/static/information_sign_gray.svg"
                                    alt="Information sign"
                                    class="mr-3 h-7 w-7"
                                />
                                <div>No output artefacts to invalidate</div>
                            </div>
                        {% else %}
                            {% for workflow_step_artefact in workflow_step_artefacts.OUTPUT %}
                                <div class="rounded-sm px-3 py-2 hover:bg-gray-100">
                                    <div class="content-start hyphens-auto break-words text-left">
                                        {{ workflow_step_artefact.properties.type }}
                                    </div>
                                    <div class="pb-1 pt-2 text-right">
                                        <!--  Invalidate button with dialogue  -->
                                        {{ macros.invalidate(workflow_step_artefact.properties.invalidated_at, job_status, workflow_step_artefact.properties.maestro_id, "artefact", "propagate") }}
                                    </div>
                                </div>
                                <!-- Separator if not last   -->
                                {% if not loop.last and artefact_count > 1 %}
                                    <hr class="border-gray-200" />
                                {% endif %}
                            {% endfor %}
                        {% endif %}
                    </div>
                </div>
                <!-- Pane for Reorder/Resume/Abort actions -->
                <div class="float-right w-1/2 pl-4">
                    <!--  Reorder workflow step  -->
                    <div class="mb-2 font-medium">
                        Reorder invalidated, cancelled or failed step
                    </div>
                    <div class="text-gray-500">
                        Reordering this step will attempt to create new output artefacts. Note that
                        this will also affect downstream steps.
                    </div>
                    <!-- Reorder button with dialogue -->
                    <div class="mx-2 my-3" id="reorder-container">
                        {{ macros.reorder(workflow_step.invalidated_at, job_maestro_id, "workflow_step", job_status) }}
                    </div>
                    <!-- Continue is only relevant for halted jobs -->
                    {% if job_status == 'JobStatus.HALTED' %}
                        <!-- Continue (resume) halted job -->
                        <div class="mb-2 mt-8 font-medium">Continue halted step</div>
                        <div class="text-gray-500">
                            Continuing this step will disregard any failed test in the inputs and
                            resume the workflow.
                        </div>
                        <!-- Continue button with dialogue -->
                        <div class="mx-2 my-3" id="resume-container">
                            {{ macros.resume(job_maestro_id, job_status) }}
                        </div>
                    {% endif %}
                    <!-- Show Abort only for relevant jobs: all inputs in place (note: pending in job_details modal) and not completed -->
                    {% if job_status in ('JobStatus.RUNNING', 'JobStatus.QUEUED', 'JobStatus.HALTED') %}
                        <!-- Abort step -->
                        <div class="mb-2 mt-8 font-medium">Abort step</div>
                        <div class="text-gray-500">
                            Aborting this step will stop the workflow and invalidate all downstream
                            steps.
                        </div>
                        <!-- Abort button with dialogue -->
                        <div class="mx-2 my-3" id="abort-container">
                            {{ macros.abort(job_maestro_id) }}
                        </div>
                    {% endif %}
                </div>
            </div>
        </div>
        <!-- footer -->
        <div id="footer" class="text-center">
            <!-- Notification for copy to clipboard at bottom of screen -->
            <div
                id="notification"
                class="notification bg-ellapurple border-ellapurple-lighter invisible fixed bottom-0 left-0 z-50 w-full text-ellipsis rounded-sm border-t p-3 text-gray-800 transition"
            ></div>
            <!-- Connected workflow, step type and (if present) job display name -->
            <div
                class="clear-both mx-4 mt-4 flex-col space-x-4 overflow-hidden bg-gray-100 p-1 text-xs text-gray-600 "
            >
                <span class="whitespace-nowrap">
                    <span class="pr-1 font-semibold">Workflow:</span>
                    <span
                        class="copyText cursor-pointer"
                        title="Click to copy"
                        _="on click call toClipboard(`{{ workflow_name }}`)"
                        >{{ workflow_name }}</span
                    >
                </span>
                <span class="whitespace-nowrap">
                    <span class="pr-1 font-semibold">Type:</span>
                    <span
                        class="copyText cursor-pointer"
                        title="Click to copy"
                        _="on click call toClipboard(`{{ workflow_step.type }}`)"
                        >{{ workflow_step.type }}</span
                    >
                </span>
                {% if job_name != workflow_step.type %}
                    <span class="whitespace-nowrap">
                        <span class="pr-1 font-semibold">Name:</span>
                        <span
                            class="copyText cursor-pointer"
                            title="Click to copy"
                            _="on click call toClipboard(`{{ job_name }}`)"
                            >{{ job_name }}</span
                        >
                    </span>
                {% endif %}
            </div>
        </div>
    </div>
</div>
